#ifndef __DB__LOCK_PH__
#define __DB__LOCK_PH__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void DbClientRestoreLocksAndTriggers ();
DbClient DbFindClient (char* name);
DbClient DbClientNew (char* name);
void DbClientRemove (DbClient client);
void DbClientSetLockMode (DbClient client, DbLockMode lock_mode);
DbLockMode DbClientGetLockMode (DbClient client);
int DbClientRequestWriteAccess (DbClient client);
int DbClientIsSame (DbClient client, char* name);
char* DbClientGetName (DbClient client);
DbBranch DbFindBranch (char* name);
DbBranch DbBranchNew (char* name);
void DbBranchRemove (DbBranch branch);
int DbBranchIsSame (DbBranch branch, char* name);
char* DbBranchGetName (DbBranch branch);
DbLock DbFindLock (char* object_name);
DbLock DbLockNew (char* object_name, DbClient client);
void DbLockRemove (DbLock lock);
DbLock DbFindLockInBranch (char* branch_name, char* object_name);
/* DbLock DbLockNewInBranch (char* branch_name, ; */
void DbLockRemoveFromBranch (char* branch_name, DbLock lock);
DbLockMode DbLockGetLockMode (DbLock lock);
void DbLockSetClient (DbLock lock, DbClient client);
DbClient DbLockGetClient (DbLock lock);
int DbLockPermitsReadForWrite (DbLock lock, char* name);
int DbLockPermitsWrite (DbLock lock, char* name);
char* DbLockGetOwner (DbLock lock);
char* DbLockGetName (DbLock lock);
void DbSendTriggers (char* object_name,
                     DbTriggerType trigger_type);
int DbTriggerAdd (char* object_name,
                  DbTriggerType trigger_type, 
                  DbClient client);
void DbTriggerRemove (char* object_name,
                      DbTriggerType trigger_type, 
                      DbClient client);
DbTrigger DbTriggerSetFindTrigger (DbTriggerSet trigger_set,
                                   DbTriggerType trigger_type,
                                   DbClient client);
DbTriggerSet DbFindTriggerSet (char* object_name);
DbTriggerSet DbTriggerSetNew (char* object_name);
void DbTriggerSetClear (DbTriggerSet trigger_set);
char* DbTriggerSetGetName (DbTriggerSet trigger_set);
void DbTriggerSetRemoveTriggers (DbTriggerSet trigger_set, DbClient client);
DbTrigger DbTriggerNew (DbTriggerType trigger_type, DbClient client);
void DbTriggerClear (DbTrigger trigger);
DbTriggerType DbTriggerGetTriggerType (DbTrigger trigger);
void DbTriggerSetClient (DbTrigger trigger, DbClient client);
DbClient DbTriggerGetClient (DbTrigger trigger);
char* DbTriggerGetOwner (DbTrigger trigger);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __DB__LOCK_PH__ */
